/*
 * Definitions for BIND_MsgStructs VERSION 1 NUMBER 20190.
 */
#ifndef __BIND_MsgStructs
#define __BIND_MsgStructs
#include <HRPC/cCourierTypes.h>
#include <HRPC/basicRpc.h>
#include <HRPC/hrpcErrCodes.h>


typedef struct {
	Integer ResponseFlag;
	Integer OpCode;
	Integer AuthAnsFlag;
	Integer TruncMsgFlag;
	Integer RecurDesFlag;
	Integer RecurAvailFlag;
	Integer PrimSvrRqdFlag;
	Integer Unused;
	Integer ResponseCode;
} BIND_MsgStructs_HdrBitFields;
extern int BIND_MsgStructs_HdrBitFieldsOtw();
typedef String BIND_MsgStructs_DName;

typedef struct {
	Integer QueryId;
	BIND_MsgStructs_HdrBitFields BitFieldsPart;
	Integer qdcount;
	Integer ancount;
	Integer nscount;
	Integer arcount;
} BIND_MsgStructs_MsgHeader;
extern int BIND_MsgStructs_MsgHeaderOtw();

typedef struct {
	String dname;
	Integer type;
	Integer class;
} BIND_MsgStructs_RRecIdent;
extern int BIND_MsgStructs_RRecIdentOtw();

typedef Unspecified BIND_MsgStructs_T_r20190_1[128];
extern int BIND_MsgStructs_T_r20190_1Otw();

typedef struct {
	BIND_MsgStructs_RRecIdent RR_Ident;
	LongInteger ttl;
	Integer nbytes;
	BIND_MsgStructs_T_r20190_1 Data;
} BIND_MsgStructs_RRec;
extern int BIND_MsgStructs_RRecOtw();

typedef struct {
	BIND_MsgStructs_MsgHeader Header;
	BIND_MsgStructs_RRecIdent Q_Ident;
} BIND_MsgStructs_LookupNameInMsg;
extern int BIND_MsgStructs_LookupNameInMsgOtw();

typedef BIND_MsgStructs_RRec BIND_MsgStructs_T_r20190_2[100];
extern int BIND_MsgStructs_T_r20190_2Otw();

typedef struct {
	BIND_MsgStructs_MsgHeader Header;
	BIND_MsgStructs_RRecIdent Q_Ident;
	BIND_MsgStructs_T_r20190_2 AnsRecs;
} BIND_MsgStructs_LookupNameOutMsg;
extern int BIND_MsgStructs_LookupNameOutMsgOtw();

typedef BIND_MsgStructs_RRec BIND_MsgStructs_T_r20190_3[100];
extern int BIND_MsgStructs_T_r20190_3Otw();

typedef struct {
	BIND_MsgStructs_MsgHeader Header;
	BIND_MsgStructs_T_r20190_3 AnsRecs;
} BIND_MsgStructs_CacheLookupNameOutMsg;
extern int BIND_MsgStructs_CacheLookupNameOutMsgOtw();

typedef struct {
	BIND_MsgStructs_MsgHeader Header;
	BIND_MsgStructs_RRec RR;
} BIND_MsgStructs_AddRRInMsg;
extern int BIND_MsgStructs_AddRRInMsgOtw();

typedef struct {
	BIND_MsgStructs_MsgHeader Header;
} BIND_MsgStructs_AddRROutMsg;
extern int BIND_MsgStructs_AddRROutMsgOtw();

typedef struct {
	BIND_MsgStructs_MsgHeader Header;
	BIND_MsgStructs_RRec RR;
} BIND_MsgStructs_DeleteRRInMsg;
extern int BIND_MsgStructs_DeleteRRInMsgOtw();

typedef struct {
	BIND_MsgStructs_MsgHeader Header;
} BIND_MsgStructs_DeleteRROutMsg;
extern int BIND_MsgStructs_DeleteRROutMsgOtw();

typedef struct {
	BIND_MsgStructs_MsgHeader Header;
	BIND_MsgStructs_RRec OldRR;
	BIND_MsgStructs_RRec NewRR;
} BIND_MsgStructs_ModifyInMsg;
extern int BIND_MsgStructs_ModifyInMsgOtw();

typedef struct {
	BIND_MsgStructs_MsgHeader Header;
} BIND_MsgStructs_ModifyOutMsg;
extern int BIND_MsgStructs_ModifyOutMsgOtw();

#endif __BIND_MsgStructs


extern HRPCErrRec *BIND_MsgStructs_Export();
extern HRPCErrRec *BIND_MsgStructs_Import();
